%% X = WU + noise, U = [U1,U2,...Un], Ui is sampled from N(0,beta^{-1}*I); Xi is sampled from N(WUi,alpha^{-1}*I)
function [W,U] = EM_PPCA(X,k,alpha,beta, max_iter, tol)
    [p,n] = size(X);
    %mean_U = zeros(k,n);    
    mean_U = 0.001*randn(k,n)/sqrt(beta);
    Sigma = eye(k)/beta;
    mean_UU = n*Sigma;
    for j=1:n
        mean_UU = mean_UU + mean_U(:,j)*mean_U(:,j)';
    end
    W = mean_UU\(mean_U*X');
    W = W';
    %W = ones(p,k);
    %initlize by svd
%     [u,s,v] = svds(X,k);
%     W = u*sqrt(s);
%     mean_U = sqrt(s)*v';

    
    for i=1: max_iter
            old_mean_U = mean_U;
            %E step
            inv_Sigma = (alpha*W'*W + beta*eye(k));
            Sigma = inv_Sigma\eye(k);
            for j=1:n
                mean_U(:,j) = inv_Sigma\(alpha*W'*X(:,j));
            end
            %fprintf('iter = %d, diff = %g\n',i, norm(reshape(old_mean_U - mean_U, k*n,1),1));
            if (norm(reshape(old_mean_U - mean_U, k*n,1),1) < tol)
                break;
            end
            %M step
            mean_UU = n*Sigma;
            for j=1:n
                mean_UU = mean_UU + mean_U(:,j)*mean_U(:,j)';
            end
            W = mean_UU\(mean_U*X');
            W = W';
    end
    U = mean_U;
end