function kernel = ker_func(X, param)
% kernel function with a minimal design

n = size(X, 1);

switch param.type
    case 'linear'
        kernel = X*X';
    case 'rbf'
        P=sum(X.*X,2);
        kernel = exp(-param.gamma*(repmat(P',n,1) + repmat(P,1,n) ... 
            - 2*(X*X'))) ;
    case 'poly'
        kernel = (X*X'+1).^param.degree ;
    otherwise
        error('Unknown kernel type');
end

kernel = kernel  + param.nu * eye(n);