%%mutlive view learning, one view is classifcation data, another view is
%%continuous data; third view is continuous response, using semisupervised 
%%method for prediction
%X: p*n; Y:q*n; z:n*1; U:k*n
%spike and slab on F
%nTrain means: U1,U2,...UnTrain is the train set; Untrain+1,...Un is the
%test data; Z is nTrain * 1 vector
%using other kernels, like RBF
function [U, t, yita, W, V, T, Q, alpha, beta] = multiview_learning4_gp_semisupervise(X,Y,Z,nTrain,k,a0,b0,c0,d0,g0,h0,max_iter, tol,sp_init, percentile,kernel_param)
  %intilization
  %suppose 3 labels: 1,2,3
  %pc = [-inf,norminv(1/3),norminv(2/3),inf];
  %so we can have any number of label types
  pc = percentile;
  if (size(pc,1) <size(pc,2))
      pc = pc';
  end
  [p,n] = size(X);
  [q,n] = size(Y);
  
  mean_W = zeros(p,k);
  Sigma_W = cell(p);
  Sigma_WjWj = cell(p);
  Sigma_WW = eye(k);
  T = sp_init*ones(p,k);
  a = a0*ones(p,k);
  b = b0*ones(p,k);
  X = X + 1;
  alpha = X - 2;    
  t = Z - 2;
 
  
  mean_V = zeros(q,k);  
  Sigma_V = cell(q);
  Sigma_VjVj = cell(q);
  Sigma_VV = eye(k);
  Q = sp_init*ones(q,k);
  c = c0*ones(q,k);
  d = d0*ones(q,k);
  beta = g0/h0;
  
  mean_U = zeros(k,n);
  Sigma_UU = zeros(k,k); 
  yita = 1;
       
 %using svd as intilization
 [u,s,v] = svds([my_normalize(X); Y],k);
 mean_WV = u*sqrt(s);
 mean_W = mean_WV(1:p,:);
 mean_V = mean_WV(p+1:end,:);
 mean_U = sqrt(s)*v';

%  mean_W = randn(p,k);
%  mean_V = randn(q,k);
%  mean_U = randn(k,n);
 
%   [mean_WV, mean_U] = EM_PPCA([my_normalize(X); Y],k,1,1,1000,1e-2);
%   mean_W = mean_WV(1:p,:);
%   mean_V = mean_WV(p+1:end,:);
  Sigma_WW = zeros(k,k);
  for i=1:p
      Sigma_WW = Sigma_WW + eye(k) + mean_W(i,:)'*mean_W(i,:);
  end
  Sigma_VV = zeros(k,k);
  for i=1:q
      Sigma_VV = Sigma_VV + eye(k) + mean_V(i,:)'*mean_V(i,:);
  end
  s1 = 1;
  s2 = 1e-6;
  
  %Sigma_WW
  %start varational inference
  for i=1:max_iter
      old_U = mean_U;
      
      %%update Q(t)
      U_train = mean_U(:, 1:nTrain);
      %C = yita^2*(U_train'*U_train) + eye(nTrain);
      C = ker_func(U_train',kernel_param);
      
      tt = zeros(nTrain,1);
      for j=1:nTrain
          nj = setdiff(1:1:nTrain, (j));
          aj = C(j,nj)*(C(nj,nj)\t(nj));
          sj = C(j,j) - C(j,nj)*(C(nj,nj)\C(nj,j));
          b1 = pc(Z(j));
          b2 = pc(Z(j)+1);             
          std_sj = sqrt(sj);
          t(j) = aj - sj*(normpdf(b2,aj,std_sj)-normpdf(b1,aj,std_sj))/(normcdf((b2-aj)/std_sj) - normcdf((b1-aj)/std_sj));
          first_term = (b2+aj)*normpdf(b2,aj,std_sj);
          if isnan(first_term)
              first_term = 0;
          end          
          second_term = (b1+aj)*normpdf(b1,aj,std_sj);
          if isnan(second_term)
              second_term = 0;
          end
          tt(j) = aj^2 + sj*(1   - (first_term - second_term)/(normcdf((b2-aj)/std_sj)-normcdf((b1-aj)/std_sj)));
      end
      tt = t*t' - diag(diag(t*t')) + diag(tt);
      
      
      %%update Q(U)
%       global_options = [];
%       global_options.order = 1; 
%       optimFunc = @L1GeneralCoordinateDescent;
%       options = global_options;
%       init_para = [mean_U(:);1];
%       lambdaVect = [ones(k*n,1);0];
%       other_args = {tt, alpha, Y, mean_W, Sigma_WW, beta, mean_V, Sigma_VV, k, n, nTrain};
%       [out] = optimFunc(@my_gp_fg,init_para,lambdaVect,options,other_args{:});
%       mean_U = reshape(out(1:end-1),k,n);
%       Sigma_UU = mean_U*mean_U';
      
      %%update Q(U) (using lbfgs method)
      %init_para = [mean_U(:);1];      
      init_para = mean_U(:);
      other_args = {tt, alpha, Y, mean_W, Sigma_WW, beta, mean_V, Sigma_VV, k, n, nTrain, kernel_param};      
      %check gradient
      %fastDerivativeCheck(@my_gp_fg_nonlinear,init_para,1,2,other_args{:});%central finite difference method      
      [out] = minFunc(@my_gp_fg_nonlinear,init_para,[],other_args{:});
      mean_U = reshape(out(1:end),k,n);
      Sigma_UU = mean_U*mean_U';
      
            
      
                  
      %update Q(W)
      %row by row
      Sigma_WW = zeros(k,k);
      mean_ww = zeros(p,k);
      for j = 1:p
          inv_Sigma_W = Sigma_UU + 1/s1*diag(T(j,:)) + 1/s2*diag(1-T(j,:));
          Sigma_W{j} = inv_Sigma_W\eye(k);
          mean_W(j,:) = (inv_Sigma_W\(mean_U*alpha(j,:)'))';          
          Sigma_WjWj{j} = Sigma_W{j} + mean_W(j,:)'*mean_W(j,:);
          Sigma_WW = Sigma_WW + Sigma_WjWj{j};
          mean_ww(j,:) = diag(Sigma_WjWj{j})';
      end
      diff = norm(reshape(old_U-mean_U,k*n,1),1);
      fprintf('iter = %d, diff = %g\n',i, diff);
      if (diff < tol)
          break;
      end
      
      %update Q(T)            
      T = 1./( 1 + exp( psi(b) - psi(a) + 0.5*log(s1/s2) + 0.5*mean_ww*(1/s1-1/s2)));
      %update Q(Sita)
      a = a0 + T;
      b = b0 + 1 - T;
      %update Q(alpha)
      A = mean_W*mean_U;
      alpha = A + (normpdf(pc(X),A,ones(size(X))) - normpdf(pc(X+1),A,ones(size(X))))./(normcdf(pc(X+1)-A) - normcdf(pc(X)-A));
      
      %update Q(V)
      %row by row
      Sigma_VV = zeros(k,k);
      mean_vv = zeros(q,k);
      for j=1:q
          inv_Sigma_V = beta*Sigma_UU + 1/s1*diag(Q(j,:)) + 1/s2*diag(1-Q(j,:));
          Sigma_V{j} = inv_Sigma_V\eye(k);
          mean_V(j,:) = (inv_Sigma_V\(beta*mean_U*Y(j,:)'))';
          Sigma_VjVj{j} = Sigma_V{j} + mean_V(j,:)'*mean_V(j,:);
          Sigma_VV = Sigma_VV + Sigma_VjVj{j};
          mean_vv(j,:) = diag(Sigma_VjVj{j});
      end
      %update Q(Q)
      Q = 1./(1 + exp(psi(d) - psi(c) + 0.5*log(s1/s2) + 0.5*mean_vv*(1/s1-1/s2)));
      %updqte Q(gamma)
      c = c0 + Q;
      d = d0 + 1 - Q;
      %update Q(beta)
      g = g0 + 0.5*q*n;
      h = h0 + 0.5*trace(Y'*Y) - trace(Y'*mean_V*mean_U) + 0.5*trace(Sigma_UU*Sigma_VV);
      beta = g/h;
      
  end
  W = mean_W;
  V = mean_V;
  U = mean_U;  
end

