function [gU] = my_kergrad_matern(U, K, KS, kernel_param)
    [d,n] = size(U);
    X = U';
    P=sum(X.*X,2);
    P = repmat(P',n,1) + repmat(P,1,n) - 2*(X*X');
    P = P.*(ones(n,n)-eye(n));    
    rmat = - sqrt(3)/kernel_param.sigma*sqrt(P);
    Coef =   -3/(kernel_param.sigma^2)*exp(rmat);
    
    gU = zeros(d, n);
    A = (eye(n)-KS)*(K\eye(n));
    A = A';
    F = zeros(n*n,n*d);
%     ct = 1;
%     for j=1:n
%         for i=1:n
%            B = sparse(d,n);
%            B(:,i) = U(:,i)-U(:,j);
%            B(:,j) = U(:,j)-U(:,i);
%            F(ct,:) = Coef(i,j)*reshape(B,d*n,1)';
%            ct = ct+1;
%         end
%     end
    for i=1:n
        D = diag(Coef(i,:))*(repmat(X(i,:),n,1) - X);
        C = mat2cell(-D, ones(1,n), d);
        B = (blkdiag( C{:} ));
        B(:,(i-1)*d+1:i*d) = D;
        F((i-1)*n+1:i*n,:) = B;
        i
    end
    gU = reshape(0.5*F'*reshape(A,n*n,1),d,n);
end

