addpath_recurse('../minFunc_2012');
data = load('ANDI_original.mat');
X= data.Y{1}';
Y = data.Y{2}';
Z = data.Y{3} + 1;
n = size(X,2);

mean_Y = mean(Y,2);
std_Y = std(Y,0,2);
for i=1:n
    Y(:,i) = (Y(:,i) - mean_Y)./std_Y;
end


ind = load('ind.mat');
ind = ind.ind;
dim = 20;
prec = zeros(10,1);
%init var para for spike & slab
%sp_init = 0.9485; %begin sparse
sp_init = 0.952;

percentile = [-inf,norminv(1/3),norminv(2/3),inf];
final_pred = [];
final_z = [];
for k=1:10
    train_ind = find(ind ~= k);
    test_ind = find(ind == k);
    train_X = X(:,train_ind);
    train_Y = Y(:,train_ind);
    train_Z = Z(train_ind);
    test_X = X(:,test_ind);
    test_Y = Y(:,test_ind);
    test_Z = Z(test_ind);      
    
    n_train = length(train_ind);
    %linear kernel
    [U, t, yita, W, V, T, Q] = multiview_learning4_gp_semisupervise([train_X test_X],[train_Y test_Y],train_Z,n_train,dim,1,1,1,1,1e-3,1e-3,200, 1e-3, sp_init, percentile);
    C = yita^2*(U'*U) + eye(size(X,2));
    %other kernel
    %kernel_param = [];
    %kernel_param.type='rbf';
    %kernel_param.gamma = 1;
    %kernel_param.nu = 1;    
    %[U, t, yita, W, V, T, Q] = multiview_learning4_gp_semisupervise_nonlinear([train_X test_X],[train_Y test_Y],train_Z,n_train,dim,1,1,1,1,1,1,200, 1e-3, sp_init, percentile,kernel_param);
    %C = ker_func(U',kernel_param);

    C11 = C(1:n_train, 1:n_train);
    C12 = C(1:n_train, n_train+1:end);
    C22 = C(n_train+1:end, n_train+1:end);
    pred_t = C12'*(C11\t(1:n_train));
    for i=1:length(pred_t)
        if (pred_t(i) < percentile(2))
            pred_t(i) = 1;
        elseif pred_t(i) < percentile(3)
            pred_t(i) = 2;
        else
            pred_t(i) = 3;
        end
    end
    prec(k) = sum(pred_t == test_Z)/length(pred_t);
    fprintf(2, 'k-th fold, prec = %g\n', prec(k));

end
fprintf(2,'10 folds, multi-view learning: prec = %g , std = %g',mean(prec),std(prec));


