%%mutlive view learning, one view is classifcation data, another view is
%%continuous data; thrid view is label, using semisupervised method for
%%prediction
%X: p*n; Y:q*n; z:n*1; U:k*n
%spike and slab on F
%nTrain means: U1,U2,...UnTrain is the train set; Untrain+1,...Un is the
%test data; Z is nTrain * 1 vector
function [W,V,U,T,Q,F,yita,mean_t,alpha,beta,Sigma_U] = multiview_learning4_semisupervise(X,Y,Z,nTrain, k,a0,b0,c0,d0,g0,h0,l0,r0,m0,o0,delta,max_iter, tol,sp_init, sp_f_init,percentile)
  %intilization
  %suppose 3 labels: 1,2,3
  %pc = [-inf,norminv(1/3),norminv(2/3),inf];
  %so we can have any number of label types
  pc = percentile;
  if (size(pc,1) <size(pc,2))
      pc = pc';
  end
  %sp_init = 0.945;
  [p,n] = size(X);
  [q,n] = size(Y);
  
  mean_W = zeros(p,k);
  Sigma_W = cell(p);
  Sigma_WjWj = cell(p);
  Sigma_WW = eye(k);
  T = sp_init*ones(p,k);
  a = a0*ones(p,k);
  b = b0*ones(p,k);
  alpha = X - 2;
  
  mean_V = zeros(q,k);  
  Sigma_V = cell(q);
  Sigma_VjVj = cell(q);
  Sigma_VV = eye(k);
  Q = sp_init*ones(q,k);
  c = c0*ones(q,k);
  d = d0*ones(q,k);
  beta = g0/h0;
  
  mean_U = zeros(k,n);
  Sigma_U = eye(k);
  Sigma_UU = zeros(k,k);
  tao = l0/r0;
  
  mean_F = 0.001*randn(k,1);
  Sigma_F = eye(k);
  Sigma_FF = eye(k);
  yita = sp_f_init*ones(k,1);
  m = m0*ones(k,1);
  o = o0*ones(k,1);
   
  
 %augziliary variable for probit regression
 %mean_t = zeros(n,1);
 mean_t = Z - 2;
  
 %using svd as intilization
 [u,s,v] = svds([my_normalize(X); Y],k);
 mean_WV = u*sqrt(s);
 mean_W = mean_WV(1:p,:);
 mean_V = mean_WV(p+1:end,:);
 mean_U = sqrt(s)*v';

%  mean_W = randn(p,k);
%  mean_V = randn(q,k);
%  mean_U = randn(k,n);
 
%  [mean_WV, mean_U] = EM_PPCA([my_normalize(X); Y],k,1,1,1000,1e-2);
%  mean_W = mean_WV(1:p,:);
%  mean_V = mean_WV(p+1:end,:);
  
  s1 = 1;
  s2 = 1e-6;
  
  %Sigma_WW
  %start varational inference
  for i=1:max_iter
      old_U = mean_U;
      
      %%update Q(U)
      %update Q(UTrain)
      inv_Sigma_Utrain = tao*eye(k) + Sigma_WW + beta*Sigma_VV + Sigma_FF;
      Sigma_Utrain = inv_Sigma_Utrain\eye(k);
      Sigma_UtrainUtrain = nTrain*Sigma_Utrain;
      for j=1:nTrain
          mean_U(:,j) = inv_Sigma_Utrain\(mean_W'*alpha(:,j) + beta*mean_V'*Y(:,j) + mean_F*(mean_t(j)));
          Sigma_UtrainUtrain = Sigma_UtrainUtrain + mean_U(:,j)*mean_U(:,j)';
      end            
      %update Q(Utest)
      inv_Sigma_Utest = tao*eye(k) + Sigma_WW + beta*Sigma_VV;
      Sigma_Utest = inv_Sigma_Utest\eye(k);
      Sigma_UtestUtest = (n - nTrain)*Sigma_Utest;
      for j=nTrain+1:n
          mean_U(:,j) = inv_Sigma_Utest\(mean_W'*alpha(:,j) + beta*mean_V'*Y(:,j));
          Sigma_UtestUtest = Sigma_UtestUtest + mean_U(:,j)*mean_U(:,j)';
      end
      Sigma_UU = Sigma_UtrainUtrain + Sigma_UtestUtest;

      %update Q(tao)
      l = l0 + 0.5*k*n;
      r = r0 + 0.5*trace(Sigma_UU);
      tao = l/r;
      
      %update Q(F)
      inv_Sigma_F = Sigma_UtrainUtrain + 1/s1*diag(yita) + 1/s2*diag(1-yita);
      Sigma_F = inv_Sigma_F\eye(k);
      mean_F = inv_Sigma_F\(mean_U(:,1:nTrain)*(mean_t));
      Sigma_FF = Sigma_F + mean_F*mean_F';
      
      %update Q(yita)
      yita = 1./(1+exp( psi(o) - psi(m) + 0.5*log(s1/s2) + 0.5*diag(Sigma_FF)*(1/s1 - 1/s2)));
      %update Q(Phi)
      m = m0 + yita;
      o = o0 + 1 - yita;      
      
      %update Q(t)
      aj = mean_U(:,1:nTrain)'*mean_F;
      mean_t = aj + (normpdf(pc(Z),aj,ones(size(Z))) - normpdf(pc(Z+1),aj,ones(size(Z))))./(normcdf(pc(Z+1)-aj) - normcdf(pc(Z) - aj));
                  
      %update Q(W)
      %row by row
      Sigma_WW = zeros(k,k);
      mean_ww = zeros(p,k);
      for j = 1:p
          inv_Sigma_W = Sigma_UU + 1/s1*diag(T(j,:)) + 1/s2*diag(1-T(j,:));
          Sigma_W{j} = inv_Sigma_W\eye(k);
          mean_W(j,:) = (inv_Sigma_W\(mean_U*alpha(j,:)'))';          
          Sigma_WjWj{j} = Sigma_W{j} + mean_W(j,:)'*mean_W(j,:);
          Sigma_WW = Sigma_WW + Sigma_WjWj{j};
          mean_ww(j,:) = diag(Sigma_WjWj{j})';
      end
      diff = norm(reshape(old_U-mean_U,k*n,1),1);
      fprintf('iter = %d, diff = %g\n',i, diff);
      if (diff < tol)
          break;
      end
      
      %update Q(T)            
      T = 1./( 1 + exp( psi(b) - psi(a) + 0.5*log(s1/s2) + 0.5*mean_ww*(1/s1-1/s2)));
      %update Q(Sita)
      a = a0 + T;
      b = b0 + 1 - T;
      %update Q(alpha)
      A = mean_W*mean_U;
      alpha = A + (normpdf(pc(X),A,ones(size(X))) - normpdf(pc(X+1),A,ones(size(X))))./(normcdf(pc(X+1)-A) - normcdf(pc(X)-A));
      
      
      %update Q(V)
      %row by row
      Sigma_VV = zeros(k,k);
      mean_vv = zeros(q,k);
      for j=1:q
          inv_Sigma_V = beta*Sigma_UU + 1/s1*diag(Q(j,:)) + 1/s2*diag(1-Q(j,:));
          Sigma_V{j} = inv_Sigma_V\eye(k);
          mean_V(j,:) = (inv_Sigma_V\(beta*mean_U*Y(j,:)'))';
          Sigma_VjVj{j} = Sigma_V{j} + mean_V(j,:)'*mean_V(j,:);
          Sigma_VV = Sigma_VV + Sigma_VjVj{j};
          mean_vv(j,:) = diag(Sigma_VjVj{j});
      end
      %update Q(Q)
      Q = 1./(1 + exp(psi(d) - psi(c) + 0.5*log(s1/s2) + 0.5*mean_vv*(1/s1-1/s2)));
      %updqte Q(gamma)
      c = c0 + Q;
      d = d0 + 1 - Q;
      %update Q(beta)
      g = g0 + 0.5*q*n;
      h = h0 + 0.5*trace(Y'*Y) - trace(Y'*mean_V*mean_U) + 0.5*trace(Sigma_UU*Sigma_VV);
      beta = g/h;
      
  end
  W = mean_W;
  V = mean_V;
  U = mean_U;
  F = mean_F;
end

