data = load('ANDI_original.mat');
X= data.Y{1}' + 1;
Y = data.Y{2}';
Z = data.Y{3} + 1;
n = size(X,2);

mean_Y = mean(Y,2);
std_Y = std(Y,0,2);
for i=1:n
    Y(:,i) = (Y(:,i) - mean_Y)./std_Y;
end

ind = load('ind.mat');
ind = ind.ind;
dim = 10;
prec = zeros(10,1);
sp_init = 0.93;
sp_f_init = 0.98;

percentile = [-inf,norminv(1/3),norminv(2/3),inf];
final_pred = [];
final_z = [];
for k=1:10
    train_ind = find(ind ~= k);
    test_ind = find(ind == k);
    train_X = X(:,train_ind);
    train_Y = Y(:,train_ind);
    train_Z = Z(train_ind);
    test_X = X(:,test_ind);
    test_Y = Y(:,test_ind);
    test_Z = Z(test_ind);  
        
    [mean_W,mean_V,mean_U,T,Q,mean_F,yita,mean_t,alpha,beta,Sigma_U] = multiview_learning4_semisupervise([train_X test_X], [train_Y test_Y],train_Z,length(train_Z),dim,1,1,1,1,1,1,1,1,1,1,1,100,1e-3,sp_init, sp_f_init, percentile);
    mean_F = mean_F.*(yita>0.5);
    t = mean_U(:,length(train_Z)+1:end)'*mean_F;
    pred = zeros(length(test_ind),1);
    for j=1:length(test_ind)
        if (t(j)<norminv(1/3))
            pred(j) = 1;
        elseif t(j)<norminv(2/3)
            pred(j) = 2;
        else
            pred(j) = 3;
        end    
    end
    prec(k) = sum(pred == test_Z)/length(test_Z)
    final_pred = [final_pred;pred];
    final_z = [final_z;test_Z];
    
end
fprintf('10 folds, multi-view learning: prec = %g , std = %g, standard err=%g\n',mean(prec),std(prec),std(prec)/sqrt(10));
[c, order] = confusionmat(final_z,final_pred);
c = c./repmat(sum(c,2),1,size(c,1))



