clear all;
close all;


%run model with LD structure

data = load('ANDI_original.mat');
X= data.Y{1}' + 1;
Y = data.Y{2}';
Z = data.Y{3} + 1;
n = size(X,2);

Lap = load('lod.mat');
Lap = Lap.lodLap;

%Lap = load('dprime.mat');
%Lap = Lap.dprimLap;

%Lap = load('rsqr.mat');
%Lap = Lap.rsqrLap;


mean_Y = mean(Y,2);
std_Y = std(Y,0,2);
for i=1:n
    Y(:,i) = (Y(:,i) - mean_Y)./std_Y;
end

ind = load('ind.mat');
ind = ind.ind;
dim = 20;
prec = zeros(10,1);
%very senstive to sp-init
sp_init = 0.973; 
sp_f_init = 0.98;
fprintf(2, 'dim = %d, sp_init = %g, sp_f_init\n', dim, sp_init);

percentile = [-inf,norminv(1/3),norminv(2/3),inf];
final_pred = [];
final_z = [];
for k=1:10
    train_ind = find(ind ~= k);
    test_ind = find(ind == k);
    train_X = X(:,train_ind);
    train_Y = Y(:,train_ind);
    train_Z = Z(train_ind);
    test_X = X(:,test_ind);
    test_Y = Y(:,test_ind);
    test_Z = Z(test_ind);      
    
    n_train = length(train_ind);
    [W,V,mean_U,T,Q,mean_F,yita,mean_t,alpha,beta,Sigma_U] = multiview_learning4_semisuperviseLD([train_X test_X],[train_Y test_Y],train_Z,n_train,dim,1,1,1,1,1,1,1,1,1,1, Lap, 50, 1e-3, sp_init,sp_f_init, percentile);
    mean_F = mean_F.*(yita>0.5);
    t = mean_U(:,length(train_Z)+1:end)'*mean_F;
    pred = zeros(length(test_ind),1);
    for j=1:length(test_ind)
        if (t(j)<norminv(1/3))
            pred(j) = 1;
        elseif t(j)<norminv(2/3)
            pred(j) = 2;
        else
            pred(j) = 3;
        end    
    end
    prec(k) = sum(pred == test_Z)/length(test_Z)
    final_pred = [final_pred;pred];
    final_z = [final_z;test_Z];
    
    
    
    fprintf(2,'%d-th fold, prec = %g\n', k,prec(k));
end
fprintf(2,'10 folds, multi-view learning: prec = %g , std = %g',mean(prec),std(prec));


